<?php
/* Copyright (c) 1998-2013 ILIAS open source, Extended GPL, see docs/LICENSE */

require_once 'Services/Repository/classes/class.ilRepositoryObjectPlugin.php';

/**
 * Class ilFormATestPlugin
 */
class ilFormATestPlugin extends ilRepositoryObjectPlugin
{
	/**
	 * @var string
	 */
	const CTYPE = 'Services';

	/**
	 * @var string
	 */
	const CNAME = 'Repository';

	/**
	 * @var string
	 */
	const SLOT_ID = 'robj';

	/**
	 * @var string
	 */
	const PNAME = 'FormATest';

	/**
	 * @var |null
	 */
	private static $instance = null;

	/**
	 * @return self
	 */
	public static function getInstance()
	{
		if(null === self::$instance)
		{
			require_once 'Services/Component/classes/class.ilPluginAdmin.php';
			return self::$instance = ilPluginAdmin::getPluginObject(
				self::CTYPE,
				self::CNAME,
				self::SLOT_ID,
				self::PNAME
			);
		}

		return self::$instance;
	}

	/**
	 * @return string
	 */
	public function getPluginName()
	{
		return self::PNAME;
	}

	/**
	 * @param string $a_type
	 * @param string $a_size
	 * @return string
	 */
	public static function _getIcon($a_type, $a_size)
	{
		return ilPlugin::_getImagePath(
			IL_COMP_SERVICE, 'Repository', 'robj',
			ilPlugin::lookupNameForId(IL_COMP_SERVICE, 'Repository', 'robj', $a_type),
			'icon_' . $a_type . '.svg'
		);
	}

	protected function uninstallCustom()
	{	
		/**
		 * @var $ilDB ilDB
		 */
		global $ilDB;
		
		if($ilDB->tableExists('rep_robj_xtsf_data'))
		{
			$ilDB->dropTable('rep_robj_xtsf_data');
		}
		
		if($ilDB->tableExists('rep_robj_xtsf_fbt'))
		{
			$ilDB->dropTable('rep_robj_xtsf_fbt');
		}
		if($ilDB->sequenceExists('rep_robj_xtsf_fbt'))
		{
			$ilDB->dropSequence('rep_robj_xtsf_fbt');
		}
		
		if($ilDB->tableExists('rep_robj_xtsf_qs'))
		{
			$ilDB->dropTable('rep_robj_xtsf_qs');
		}
		
		if($ilDB->tableExists('rep_robj_xtsf_session'))
		{
			$ilDB->dropTable('rep_robj_xtsf_session');
		}
		if($ilDB->sequenceExists('rep_robj_xtsf_session'))
		{
			$ilDB->dropSequence('rep_robj_xtsf_session');
		}
		
		if($ilDB->tableExists('rep_robj_xtsf_set_trck'))
		{
			$ilDB->dropTable('rep_robj_xtsf_set_trck');
		}
		
		if($ilDB->tableExists('rep_robj_xtsf_solut'))
		{
			$ilDB->dropTable('rep_robj_xtsf_solut');
		}
		
		if($ilDB->tableExists('rep_robj_xtsf_tracking'))
		{
			$ilDB->dropTable('rep_robj_xtsf_tracking');
		}
		
		if($ilDB->tableExists('rep_robj_xtsf_trck_his'))
		{
			$ilDB->dropTable('rep_robj_xtsf_trck_his');
		}
	}
}