<?php
/* Copyright (c) 1998-2013 ILIAS open source, Extended GPL, see docs/LICENSE */

require_once 'Services/Repository/classes/class.ilObjectPluginListGUI.php';

/**
 *
 */
class ilObjFormATestListGUI extends ilObjectPluginListGUI
{
	/**
	 * @return string
	 */
	public function getGuiClass()
	{
		return 'ilObjFormATestGUI';
	}

	/**
	 * @return array
	 */
	public function initCommands()
	{
		$this->copy_enabled = false;

		return array
		(
			array(
				'permission' => 'visible',
				'cmd'        => 'ilFormATestInfoScreenControllerGUI.show',
				'default'    => true
			),
			array(
				'permission' => 'write',
				'cmd'        => 'ilFormATestPropertiesGUI.edit',
				'txt'        => $this->lng->txt('edit'),
				'default'    => false
			),
		);
	}

	/**
	 * {@inheritdoc}
	 */
	function insertInfoScreenCommand()
	{
		if($this->std_cmd_only)
		{
			return;
		}
		$cmd_link = $this->getCommandLink('ilFormATestInfoScreenControllerGUI.show');
		$cmd_frame = $this->getCommandFrame('infoScreen');
		$this->insertCommand($cmd_link, $this->lng->txt('info_short'), $cmd_frame);
	}

	/**
	 *
	 */
	public function initType()
	{
		$this->setType('xtsf');
	}

	/**
	 * @return array
	 */
	public function getProperties()
	{
		/**
		 * @var $lng ilLanguage
		 */
		global $lng;

		$props = array();
		include_once "class.ilObjFormATestAccess.php";

		if (!ilObjFormATestAccess::checkOnline($this->obj_id))
		{
			$props[] = array("alert" => true, "property" => $lng->txt("status"),
							 "value" => $lng->txt("offline"));
		}

		return $props;
	}
}
