<?php

require_once "abstract.ilXTSFControllerTableGUI.php";

/**
 * Class ilFormATestParticipantsGUI
 *
 * Date: 17.01.14
 * Time: 11:21
 * @author Thomas Joußen <tjoussen@databay.de>
 */ 
class ilFormATestParticipantsGUI extends ilXTSFControllerTableGUI
{

	public function show()
	{
		$this->controller->ensurePermission("write");

		$table = new ilFormATestParticipantsTableGUI($this->controller, $this->plugin, "");
		$table->setModelList($this->controller->object->getParticipants());
		$table->populate();
		$table->addCommandButton("ilFormATestParticipantsGUI.removeAllResults", $this->plugin->txt("remove_all_results"));
		$table->addMultiCommand("ilFormATestParticipantsGUI.showSelectedUserResults", $this->plugin->txt("show_results"));
		$table->addMultiCommand("ilFormATestParticipantsGUI.showSelectedUserAnswers", $this->plugin->txt("show_answers"));
		$table->addMultiCommand("ilFormATestParticipantsGUI.showSelectedUserDetails", $this->plugin->txt("show_details"));
		$table->addMultiCommand("ilFormATestParticipantsGUI.removeSelectedUserResults", $this->plugin->txt("remove_results"));
		$this->tpl->setContent($table->getHTML());
	}

	public function showUserResults()
	{
		$this->controller->ensurePermission("write");
		$this->addToolbarButton("back", "ilFormATestParticipantsGUI.show");

		$this->toolbar->addButton($this->lng->txt('print'), 'javascript:window.print();');
		/*$src = ilUtil::getHtmlPath(ilUtil::getImagePath("application-pdf.png"));
		$img = '<img src="'.$src.'" style="height: 14px; position:relative; top: -1px; margin-right: 3px;" />';
		$this->ctrl->setParameter($this->controller, 'active_id', (int)$_GET["active_id"]);
		$this->ctrl->setParameter($this->controller, 'pdf', '1');
		$this->toolbar->addButton($img . $this->lng->txt('pdf_export'), $this->ctrl->getLinkTarget($this->controller, __CLASS__ . '.showUserResults'));
		$this->ctrl->setParameter($this->controller, 'pdf', '');*/
		$this->tpl->addCss(ilUtil::getStyleSheetLocation('output', 'test_print.css', 'Modules/Test'), 'print');

		$output = new ilFormATestResultOuputGUI($this->controller);
		$output->setHeader($this->plugin->txt("test_pass_overview_author"));
		$output->renderTestData(ilFormATestSession::getUserIdByActiveId((int)$_GET["active_id"]));
		$output->renderPassesOverview((int)$_GET["active_id"]);

		/*if(isset($_GET['pdf']) && $_GET['pdf'] == 1)
		{
			require_once 'Modules/Test/classes/class.ilTestPDFGenerator.php';
			ilTestPDFGenerator::generatePDF($output->getHTML(), ilTestPDFGenerator::PDF_OUTPUT_DOWNLOAD, $this->controller->object->getTitle());
		}*/

		$this->tpl->setContent($output->getHTML());
	}

	public function showUserDetails()
	{
		$this->controller->ensurePermission("write");

		$user_id = ilFormATestSession::getUserIdBySessionId((int)$_GET["session_id"]);
		$output = new ilFormATestResultOuputGUI($this->controller);
		$output->setHeader($this->plugin->txt("test_pass_overview_author"));
		$output->renderTestData($user_id);
		$output->renderStepsOverview((int)$_GET["session_id"]);
		$output->renderQuestionDetails((int)$_GET["session_id"], $this->controller->object->getSetList()->getData(), true, null, true);

		$this->addToolbarButton("back", "ilFormATestParticipantsGUI.showUserResults", array(
			"active_id" => ilFormATestSession::getActiveIdBySessionId((int)$_GET["session_id"])
		));

		$this->toolbar->addButton($this->lng->txt('print'), 'javascript:window.print();');
		/*$src = ilUtil::getHtmlPath(ilUtil::getImagePath("application-pdf.png"));
		$img = '<img src="'.$src.'" style="height: 14px; position:relative; top: -1px; margin-right: 3px;" />';
		$this->ctrl->setParameter($this->controller, 'session_id', (int)$_GET["session_id"]);
		$this->ctrl->setParameter($this->controller, 'pdf', '1');
		$this->toolbar->addButton($img . $this->lng->txt('pdf_export'), $this->ctrl->getLinkTarget($this->controller, __CLASS__ . '.showUserDetails'));
		$this->ctrl->setParameter($this->controller, 'pdf', '');*/
		$this->tpl->addCss(ilUtil::getStyleSheetLocation('output', 'test_print.css', 'Modules/Test'), 'print');

		/*if(isset($_GET['pdf']) && $_GET['pdf'] == 1)
		{
			require_once 'Modules/Test/classes/class.ilTestPDFGenerator.php';
			ilTestPDFGenerator::generatePDF($output->getHTML(), ilTestPDFGenerator::PDF_OUTPUT_DOWNLOAD, $this->controller->object->getTitle());
		}*/

		$this->tpl->setContent($output->getHTML());
	}


	public function showSelectedUserResults()
	{
		$template = $this->initMultipleUserAction();

		foreach($_POST["s_id"] as $session_id)
		{
			$user_id = ilFormATestSession::getUserIdBySessionId($session_id);
			$output = new ilFormATestResultOuputGUI($this->controller);
			$output->setModus(ilFormATestResultOuputGUI::MODUS_AUTHOR);
			$output->setHeader($this->plugin->txt("test_pass_overview_author"));
			$output->renderTestData($user_id);
			$output->renderStepsOverview($session_id);

			$template->setCurrentBlock("user_ouput");
			$template->setVariable("USER_OUTPUT", $output->getHTML());
			$template->parseCurrentBlock();
		}

		$this->tpl->setContent($template->get());
	}

	public function showSelectedUserAnswers()
	{
		$template = $this->initMultipleUserAction();

		foreach($_POST["s_id"] as $session_id)
		{
			$user_id = ilFormATestSession::getUserIdBySessionId($session_id);
			$output = new ilFormATestResultOuputGUI($this->controller);
			$output->setHeader($this->plugin->txt("test_pass_overview_author"));
			$output->renderTestData($user_id);
			$output->renderQuestionDetails($session_id, $this->controller->object->getSetList()->getData(), true, null, true);

			$template->setCurrentBlock("user_ouput");
			$template->setVariable("USER_OUTPUT", $output->getHTML());
			$template->parseCurrentBlock();
		}

		$this->tpl->setContent($template->get());
	}

	public function showSelectedUserDetails()
	{
		$template = $this->initMultipleUserAction();

		foreach($_POST["s_id"] as $session_id)
		{
			$user_id = ilFormATestSession::getUserIdBySessionId($session_id);
			$output = new ilFormATestResultOuputGUI($this->controller);
			$output->setHeader($this->plugin->txt("test_pass_overview_author"));
			$output->renderTestData($user_id);
			$output->renderStepsOverview($session_id);
			$output->renderQuestionDetails($session_id, $this->controller->object->getSetList()->getData(), true, null, true);

			$template->setCurrentBlock("user_ouput");
			$template->setVariable("USER_OUTPUT", $output->getHTML());
			$template->parseCurrentBlock();
		}

		$this->tpl->setContent($template->get());
	}

	public function removeSelectedUserResults()
	{
		$this->controller->ensurePermission("write");

		if(!$this->dataSelected("s_id"))
		{
			ilUtil::sendFailure($this->plugin->txt("no_user_selected"), true);
			$this->redirect("ilFormATestParticipantsGUI.show");
		}

		if((int)$_GET["confirmed"])
		{
			$this->controller->object->getParticipants()->removeBySessionIds($_POST["s_id"]);
			ilLPStatusWrapper::_refreshStatus($this->controller->object->getId());
			$this->controller->object->logAction($this->lng->txtlng("rep_robj_xqsp", "log_selected_user_data_removed", ilObjAssessmentFolder::_getLogLanguage()));
			ilUtil::sendSuccess($this->plugin->txt("all_data_deleted"));
			$this->redirect("ilFormATestParticipantsGUI.show");
		}
		else
		{
			$items = array();
			foreach($_POST["s_id"] as $session_id)
			{
				$user_id = ilFormATestSession::getUserIdBySessionId($session_id);
				$items[] = array(
					"name" =>"s_id[]",
					"id" => $session_id,
					"text" => ilUserUtil::getNamePresentation($user_id)
				);
			}

			$this->renderConfirmationScreen(
				"ilFormATestParticipantsGUI.show",
				"ilFormATestParticipantsGUI.removeSelectedUserResults",
				$items,
				$this->plugin->txt("remove_selected_results_confirm")
			);
		}
	}

	public function removeAllResults()
	{
		$this->controller->ensurePermission("write");
		if((int)$_GET["confirmed"])
		{
			$this->controller->object->getParticipants()->removeAll();
			ilLPStatusWrapper::_refreshStatus($this->controller->object->getId());
			ilUtil::sendSuccess($this->plugin->txt("all_data_deleted"));
			$this->controller->object->logAction($this->plugin->txt("log_user_data_removed"));
			$this->redirect("ilFormATestParticipantsGUI.show");
		}
		else
		{
			$this->renderConfirmationScreen(
				"ilFormATestParticipantsGUI.show",
				"ilFormATestParticipantsGUI.removeAllResults",
				array(),
				$this->plugin->txt("remove_all_results_confirm")
			);
		}
	}

	/**
	 * Returns the current tab name
	 * return string
	 */
	protected function getCurrentTab()
	{
		return "participants";
	}

	/**
	 * @return array
	 */
	protected function getRequirements()
	{
		require_once "Services/User/classes/class.ilUserUtil.php";
		require_once "Services/Utilities/classes/class.ilConfirmationGUI.php";
		require_once "Services/Tracking/classes/class.ilLPStatusWrapper.php";
		require_once "Services/Tracking/classes/status/class.ilLPStatusEvent.php";

		return array(
			"tables/class.ilFormATestParticipantsTableGUI.php",
			"controllers/class.ilFormATestResultOuputGUI.php",
			"models/class.ilFormATestSession.php"
		);
	}

	/**
	 * @return ilTemplate
	 */
	protected function initMultipleUserAction()
	{
		$this->controller->ensurePermission("write");
		$this->addToolbarButton("back", "ilFormATestParticipantsGUI.show");

		if (!$this->dataSelected("s_id"))
		{
			ilUtil::sendFailure($this->plugin->txt("no_user_selected"), true);
			$this->redirect("ilFormATestParticipantsGUI.show");
		}

		$template = new ilTemplate("tpl.il_multiple_user_output.html", true, true, "Customizing/global/plugins/Services/Repository/RepositoryObject/FormATest");

		return $template;
	}
}
 