<?php

require_once 'class.ilFormATestPropertiesGUI.php';

/**
 * Class ilFormATestScoringAndResultPropertiesGUI
 */
class ilFormATestScoringAndResultPropertiesGUI extends ilFormATestPropertiesGUI
{
	/**
	 * @param ilXTSFModel $model
	 * @return mixed|void
	 */
	protected function initForm($model)
	{
		require_once 'Services/Form/classes/class.ilPropertyFormGUI.php';
		$this->form = new ilPropertyFormGUI();
		$this->form->setTitle($this->controller->lng->txt('test_results'));
		$this->form->setTableWidth('100%');
		$this->form->setId('xtsf_scoring_results');
		$this->form->setFormAction($this->ctrl->getFormAction($this->controller));

		// access to test results
		$results_access = new ilRadioGroupInputGUI($this->controller->lng->txt('tst_results_access'), 'score_reporting');
		$results_access->addOption(new ilRadioOption($this->lng->txt('tst_results_access_always'), ilObjFormATest::SCORE_REPORTING_ALWAYS, ''));
		$results_access->addOption(new ilRadioOption($this->lng->txt('tst_results_access_finished'), ilObjFormATest::SCORE_REPORTING_FINISHED, ''));
		$results_access_date_limitation = new ilRadioOption($this->lng->txt('tst_results_access_date'), ilObjFormATest::SCORE_REPORTING_DATE, '');
		$results_access->addOption($results_access_date_limitation);
		$results_access->addOption(new ilRadioOption($this->controller->lng->txt('tst_results_access_never'), ilObjFormATest::SCORE_REPORTING_NEVER, ''));
		$results_access->setInfo($this->controller->lng->txt('tst_results_access_description'));

		// access date
		$reporting_date = new ilDateTimeInputGUI('', 'reporting_date');
		$reporting_date->setShowTime(true);
		$reporting_date->setDate(new ilDateTime(time(), IL_CAL_UNIX));

		$results_access_date_limitation->addSubItem($reporting_date);

		$this->form->addItem($results_access);

		$this->form->addCommandButton('ilFormATestScoringAndResultPropertiesGUI.update', $this->plugin->txt("save"));
	}

	protected function canUpdate()
	{
		return true;
	}

	/**
	 * Get the redirect action after an update was successful
	 * @return string
	 */
	protected function getAfterUpdateRedirectCmd()
	{
		return "ilFormATestScoringAndResultPropertiesGUI.edit";
	}
} 