<?php

require_once "interface.ilXTSFModelInterface.php";

/**
 * Class ilXTSFModel
 *
 * Date: 21.11.13
 * Time: 11:17
 * @author Thomas Joußen <tjoussen@databay.de>
 */ 
abstract class ilXTSFModel implements ilXTSFModelInterface
{

	/**
	 * @var int
	 */
	protected $id;

	/**
	 * @var ilObjQuestionSetPool
	 */
	protected $question_set_pool;

	public function __construct(ilObjQuestionSetPool $question_set_pool, $id = 0)
	{
		$this->question_set_pool = $question_set_pool;
		$this->id = $id;
	}

	//abstract protected function create();
	//abstract protected function update();

	/**
	 * @param int $id
	 */
	public function setId($id)
	{
		$this->id = $id;
	}

	/**
	 * @return int
	 */
	public function getId()
	{
		return $this->id;
	}

	/**
	 * @param \ilObjQuestionSetPool $question_set_pool
	 */
	public function setQuestionSetPool($question_set_pool)
	{
		$this->question_set_pool = $question_set_pool;
	}

	/**
	 * @return \ilObjQuestionSetPool
	 */
	public function getQuestionSetPool()
	{
		return $this->question_set_pool;
	}


	/**
	 * @return array
	 */
	public function toArray()
	{
		$result = array();
		foreach($this as $key => $value)
		{
			$result[$key] = $value;
		}

		return $result;
	}

}
 