<?php

/**
 * Class ilPluginModelList
 *
 * Date: 06.11.13
 * Time: 11:24
 * @author Thomas Joußen <tjoussen@databay.de>
 */ 
abstract class ilXTSFModelList
{

	/**
	 * @var ilDB
	 */
	protected $db;

	/**
	 * @var array
	 */
	private $data;

	/**
	 * @var boolean
	 */
	protected $loaded;

	/**
	 * @var ilObjFormATest
	 */
	public $form_a_test;

	public function __construct(ilObjFormATest $form_a_test)
	{
		global $ilDB;

		$this->form_a_test = $form_a_test;
		$this->db = $ilDB;
	}

	/**
	 * @return array
	 */
	public function getData()
	{
		if(!$this->isLoaded())
		{
			$data = $this->loadData();
			$this->data = $this->createObjectsFromData($data);
			$this->setLoaded(true);
		}

		return $this->data;
	}

	/**
	 * @param boolean $loaded
	 */
	public function setLoaded($loaded)
	{
		$this->loaded = $loaded;
	}

	/**
	 * @return boolean
	 */
	public function isLoaded()
	{
		return $this->loaded;
	}

	/**
	 * @return array
	 */
	abstract public function loadData();

	/**
	 * @param array $data
	 *
	 * @return array
	 */
	abstract public function createObjectsFromData($data);
}
 