<?php

require_once "./Customizing/global/plugins/Services/Repository/RepositoryObject/FormATest/classes/models/abstract.ilXTSFModelList.php";

/**
 * Class ilFormATestQuestionSetPoolSetList
 *
 * Date: 06.11.13
 * Time: 14:56
 * @author Thomas Joußen <tjoussen@databay.de>
 */ 
class ilFormATestQuestionSetPoolSetList extends ilXTSFModelList
{

	/**
	 * @return array
	 */
	public function loadData()
	{
		require_once "./Customizing/global/plugins/Services/Repository/RepositoryObject/QuestionSetPool/classes/class.ilObjQuestionSetPool.php";
		require_once "./Customizing/global/plugins/Services/Repository/RepositoryObject/FormATest/classes/providers/class.ilFormATestSetBrowserProvider.php";

		$available_pools = array_keys(ilObjQuestionSetPool::getAvailableQuestionSetPools());

		if(count($available_pools) == 0)
		{
			return null;
		}

		$provider = new ilFormATestSetBrowserProvider();
		$data = $provider->loadData(array(
			"set_pools" => $available_pools,
			"form_a_test" => $this->form_a_test->getId()
		));

		return $data;
	}

	/**
	 * @param array $data
	 *
	 * @return array
	 */
	public function createObjectsFromData($data)
	{
		return $data;
	}
}
 