<?php

require_once "abstract.ilXTSFModel.php";

/**
 * Class ilFormATestResult
 *
 * Date: 16.01.14
 * Time: 16:18
 * @author Thomas Joußen <tjoussen@databay.de>
 */ 
class ilFormATestResult
{

	protected $session_id;

	protected $active_id;

	protected $pass;

	protected $start_date;

	protected $end_date;

	protected $status;

	protected $answered_questions;

	protected $question_count;

	protected $tstamp;

	protected $points;

	protected $max_points;

	/**
	 * @param array $data
	 */
	public function init($data)
	{
		$this->session_id = $data["session_id"];
		$this->active_id = $data["active_id"];
		$this->pass = $data["pass"];
		$this->start_date = $data["start_date"];
		$this->end_date = $data["end_date"];
		$this->answered_questions = $data["answeredquestions"];
		$this->question_count = $data["questioncount"];
		$this->points = $data["points"];
		$this->max_points = $data["maxpoints"];
		$this->status = $data["status"];
	}

	/**
	 * @return mixed
	 */
	public function getActiveId()
	{
		return $this->active_id;
	}

	/**
	 * @return mixed
	 */
	public function getAnsweredQuestions()
	{
		return $this->answered_questions;
	}

	/**
	 * @return mixed
	 */
	public function getEndDate()
	{
		return $this->end_date;
	}

	/**
	 * @return mixed
	 */
	public function getMaxPoints()
	{
		return $this->max_points;
	}

	/**
	 * @return mixed
	 */
	public function getPass()
	{
		return $this->pass;
	}

	/**
	 * @return mixed
	 */
	public function getPoints()
	{
		return $this->points;
	}

	/**
	 * @return mixed
	 */
	public function getQuestionCount()
	{
		return $this->question_count;
	}

	/**
	 * @return mixed
	 */
	public function getSessionId()
	{
		return $this->session_id;
	}

	/**
	 * @return mixed
	 */
	public function getStartDate()
	{
		return $this->start_date;
	}

	/**
	 * @return mixed
	 */
	public function getTstamp()
	{
		return $this->tstamp;
	}

	/**
	 * @return float
	 */
	public function getReachedPercentage()
	{
		return ($this->points / $this->max_points) * 100;
	}

	public function toArray()
	{
		return array(
			"session_id" => $this->session_id,
			"active_id" => $this->active_id,
			"pass" => $this->pass,
			"start_date" => $this->start_date,
			"end_date" => $this->end_date,
			"status" => $this->status,
			"answered_questions" => $this->answered_questions,
			"question_count" => $this->question_count,
			"tstamp" => $this->tstamp,
			"points" => $this->points,
			"max_points" => $this->max_points
		);
	}

}
 