<?php

require_once "class.ilFormATestResult.php";
require_once "abstract.ilXTSFModelList.php";

/**
 * Class ilFormATestResultList
 *
 * Date: 17.01.14
 * Time: 09:51
 * @author Thomas Joußen <tjoussen@databay.de>
 */ 
class ilFormATestResultList extends ilXTSFModelList
{

	/**
	 * @var int $active_id
	 */
	protected $active_id;

	/**
	 * @var ilFormATestResult[]
	 */
	protected $results = array();

	/**
	 * @var ilDB
	 */
	protected $db;

	/**
	 * @param int $active_id
	 */
	public function __construct($active_id)
	{
		global $ilDB;

		$this->active_id = $active_id;
		$this->db = $ilDB;
	}

	/**
	 * @return \ilFormATestResult[]
	 */
	public function getResults()
	{
		return $this->results;
	}

	public function loadData()
	{
		$result = $this->db->queryF(
			"SELECT * FROM tst_pass_result result
			INNER JOIN rep_robj_xtsf_session session ON session.active_id = result.active_fi
			WHERE session.active_id = %s AND session.current_pass = result.pass
			ORDER BY session.current_pass ASC",
			array('integer'),
			array($this->active_id)
		);

		while($row = $this->db->fetchAssoc($result))
		{
			$model = new ilFormATestResult();
			$model->init($row);
			$this->results[] = $model;
		}
	}

	public function getData()
	{
		$this->loadData();
		return $this->results;
	}

	/**
	 * @param array $data
	 *
	 * @return array
	 */
	public function createObjectsFromData($data)
	{
		return $data;
	}
}
 