<?php

/**
 * Class ilFormATestSetResultList
 *
 * Date: 22.01.14
 * Time: 12:15
 * @author Thomas Joußen <tjoussen@databay.de>
 */ 
class ilFormATestSetResultList extends ilXTSFModelList
{

	/**
	 * @var int
	 */
	protected $set_id;

	/**
	 * @var int
	 */
	protected $session_id;

	public function __construct(ilObjFormATest $form_a_test, $set_id, $session_id)
	{
		$this->session_id = $session_id;
		$this->set_id = $set_id;
		parent::__construct($form_a_test);
	}

	/**
	 * @return array
	 */
	public function loadData()
	{
		$query = "SELECT tracking.step,tracking.matched_condition,tracking.matched_condition_id,matched_path.title, qs_qst.question_fi, qs_qst.question_index, questions.title as question_title, path.title as path_title, tst_result.points as reached_points,
			(CASE
				WHEN node.dominant_scoring IS NOT NULL
				THEN node.dominant_scoring
				ELSE questions.points
			END) max_points, node.id, tracking.set_fi, sess.active_id
			FROM rep_robj_xtsf_tracking tracking
			INNER JOIN rep_robj_xtsf_session sess ON sess.session_id = tracking.session_fi
			INNER JOIN rep_robj_xqsp_node node ON node.id = tracking.node_fi
			LEFT JOIN rep_robj_xqsp_node matched_node ON matched_node.id = tracking.matched_condition_node_id
			LEFT JOIN rep_robj_xqsp_path matched_path ON matched_path.id = matched_node.path_fi
			INNER JOIN rep_robj_xqsp_path path ON path.id = node.path_fi
			INNER JOIN qpl_questions questions ON questions.question_id = node.question_fi
			INNER JOIN rep_robj_xqsp_qs_qst qs_qst ON qs_qst.question_fi = questions.question_id
			INNER JOIN tst_test_result tst_result ON tst_result.question_fi = qs_qst.question_fi
			INNER JOIN tst_pass_result pass_result ON pass_result.active_fi = sess.active_id AND pass_result.pass = sess.current_pass
			AND tst_result.active_fi = sess.active_id
			AND tst_result.pass = sess.current_pass
			AND tst_result.step = tracking.step
			WHERE tracking.set_fi = %s AND sess.session_id = %s
			ORDER BY tracking.step ASC";

		$result = $this->db->queryF(
			$query,
			array("integer", "integer"),
			array($this->set_id, $this->session_id)
		);

		$data = array();
		while($row = $this->db->fetchAssoc($result))
		{
			$data[] = $row;
		}

		return $data;
	}

	/**
	 * @param array $data
	 *
	 * @return array
	 */
	public function createObjectsFromData($data)
	{
		return $data;
	}
}
 