<?php

/**
 * Class ilFormATestSetStepList
 *
 * Date: 22.01.14
 * Time: 12:15
 * @author Thomas Joußen <tjoussen@databay.de>
 */ 
class ilFormATestSetStepList extends ilXTSFModelList
{

	/**
	 * @var int
	 */
	protected $set_id;

	/**
	 * @var int
	 */
	protected $session_id;

	public function __construct(ilObjFormATest $form_a_test, $set_id, $session_id)
	{
		$this->session_id = $session_id;
		$this->set_id = $set_id;
		parent::__construct($form_a_test);
	}

	/**
	 * @return array
	 */
	public function loadData()
	{
		$data = array();

		if($this->form_a_test->isAllowWalkBack())
		{
			$result = $this->db->queryF(
				"SELECT path.questionset_fi, node.id, node.node_index, qst.title, qs_qst.question_index
				FROM rep_robj_xqsp_qs_qst qs_qst
				INNER JOIN qpl_questions qst ON qst.question_id = qs_qst.question_fi
				INNER JOIN rep_robj_xqsp_node node ON qs_qst.question_fi = node.question_fi AND node.node_index = 1
				INNER JOIN rep_robj_xqsp_path path ON path.id = node.path_fi AND path.path_index = 1
				WHERE path.questionset_fi = %s",
				array("integer"),
				array($this->set_id)
			);

			while($row = $this->db->fetchAssoc($result))
			{
				$data[$row["question_index"]] = $row;
			}
		}

		$result = $this->db->queryF(
			"SELECT path.questionset_fi, node.id, node.node_index, qst.title, qs_qst.question_index
			FROM rep_robj_xqsp_qs_qst qs_qst
			INNER JOIN qpl_questions qst ON qst.question_id = qs_qst.question_fi
			INNER JOIN rep_robj_xqsp_node node ON qs_qst.question_fi = node.question_fi
			INNER JOIN rep_robj_xtsf_tracking tr ON tr.node_fi = node.id
			INNER JOIN rep_robj_xqsp_path path ON path.id = node.path_fi
			WHERE path.questionset_fi = %s AND tr.session_fi = %s
			ORDER BY tr.step ASC",
			array("integer", "integer"),
			array($this->set_id, $this->session_id)
		);

		while($row = $this->db->fetchAssoc($result))
		{
			$data[$row["question_index"]] = $row;
		}

		return $data;
	}

	/**
	 * @param array $data
	 *
	 * @return array
	 */
	public function createObjectsFromData($data)
	{
		return $data;
	}
}
 