<?php

require_once "abstract.ilXTSFTableDatabaseDataProvider.php";

/**
 * Class ilFormATestParticipantsProvider
 *
 * Date: 20.01.14
 * Time: 15:59
 * @author Thomas Joußen <tjoussen@databay.de>
 */ 
class ilFormATestParticipantsProvider extends ilXTSFTableDatabaseDataProvider
{

	/**
	 * @return string
	 */
	protected function getSelectPart()
	{
		$select =  join(", ", array(
			"session.session_id",
			"tst_active.active_id",
			"tst_active.user_fi",
			"tst_active.tstamp",
			"usr_data.usr_id",
			"usr_data.login",
			"session.current_pass+1 passes"
		));

		//$select .= ", (SELECT COUNT(session.current_pass) FROM rep_robj_xtsf_session s2
		//WHERE s2.active_id = tst_active.acitve_id) passes";

		return $select;
	}

	/**
	 * @return string
	 */
	protected function getFromPart()
	{
		return "tst_active";
	}

	/**
	 * @param array $filter
	 *
	 * @return string
	 */
	protected function getJoinPart(array $filter)
	{
		return join(" ", array(
			"LEFT JOIN usr_data ON usr_data.usr_id = tst_active.user_fi",
			"INNER JOIN rep_robj_xtsf_session session ON session.active_id = tst_active.active_id
			AND session.current_pass = tst_active.tries"
		));
	}

	/**
	 * @param array $filter
	 *
	 * @return string
	 */
	protected function getWherePart(array $filter)
	{
		return join(" AND ", array(
			"tst_active.test_fi = ". $this->db->quote($filter["test_id"], "integer")
		));
	}

	/**
	 * @return string
	 */
	protected function getGroupByPart()
	{
		return join(", ", array(
			"tst_active.active_id",
			"tst_active.user_fi",
			"tst_active.tstamp",
			"session.session_id",
			"usr_data.usr_id",
			"usr_data.login",
			"passes"
		));
	}

	/**
	 * @param array $filter
	 *
	 * @return string
	 */
	protected function getHavingPart(array $filter)
	{
	}

	/**
	 * @param array $params
	 *
	 * @return string
	 */
	protected function getOrderByPart(array $params)
	{
		// TODO: Implement getOrderByPart() method.
	}
}
 