<?php

require_once 'abstract.ilXTSFTableDatabaseDataProvider.php';

/**
 * Class ilFormATestQuestionListProvider
 *
 * @author  Thomas Joußen <tjoussen@databay.de>
 * @since   01.04.15
 */
class ilFormATestQuestionListProvider extends ilXTSFTableDatabaseDataProvider
{

	/**
	 * @return string
	 */
	protected function getSelectPart()
	{
		return join(',', array('title','question_index','question_fi'));
	}

	/**
	 * @return string
	 */
	protected function getFromPart()
	{
		return 'rep_robj_xtsf_qs';
	}

	/**
	 * @param array $filter
	 *
	 * @return string
	 */
	protected function getJoinPart(array $filter)
	{
		return join(' ', array(
			'INNER JOIN rep_robj_xqsp_qs ON rep_robj_xqsp_qs.id = rep_robj_xtsf_qs.questionset_fi',
			'INNER JOIN rep_robj_xqsp_qs_qst ON rep_robj_xqsp_qs_qst.questionset_fi = rep_robj_xtsf_qs.questionset_fi'
	   ));
	}

	/**
	 * @param array $filter
	 *
	 * @return string
	 */
	protected function getWherePart(array $filter)
	{
		return $this->db->equals('rep_robj_xtsf_qs.obj_fi', $filter['obj_fi'], 'integer');
	}

	/**
	 * @return string
	 */
	protected function getGroupByPart()
	{
		return '';
	}

	/**
	 * @param array $filter
	 *
	 * @return string
	 */
	protected function getHavingPart(array $filter)
	{
		return '';
	}

	/**
	 * @param array $params
	 *
	 * @return string
	 */
	protected function getOrderByPart(array $params)
	{
		return 'sorting, question_index ASC';
	}
}
 