<?php

require_once "abstract.ilXTSFTableDatabaseDataProvider.php";

/**
 * Class ilFormATestSetBrowserProvider
 *
 * Date: 10.12.13
 * Time: 16:21
 * @author Thomas Joußen <tjoussen@databay.de>
 */ 
class ilFormATestSetBrowserProvider extends ilXTSFTableDatabaseDataProvider
{

	/**
	 * @return string
	 */
	protected function getSelectPart()
	{
		return join(",", array(
			"qsp_set.id",
			"qsp_set.title",
			"qsp_set.description",
			"qsp_set.questionsetpool_fi"
		));
	}

	/**
	 * @return string
	 */
	protected function getFromPart()
	{
		return "rep_robj_xqsp_qs qsp_set";
	}

	/**
	 * @param array $filter
	 *
	 * @return string
	 */
	protected function getJoinPart(array $filter)
	{
		return join(" ", array(
			"INNER JOIN object_data od ON od.obj_id = qsp_set.questionsetpool_fi AND od.type = " . $this->db->quote('xqsp', 'text'),
			"INNER JOIN rep_robj_xqsp_path xqsp_path ON xqsp_path.questionset_fi = qsp_set.id",
			"LEFT JOIN rep_robj_xtsf_qs fat_set ON fat_set.questionset_fi = qsp_set.id AND fat_set.obj_fi = " . $this->db->quote($filter["form_a_test"], "integer")
		));
	}

	/**
	 * @param array $filter
	 *
	 * @return string
	 */
	protected function getWherePart(array $filter)
	{
		return join(" AND ", array(
			$this->db->in("qsp_set.questionsetpool_fi", $filter["set_pools"], false, "integer"),
			"fat_set.questionset_fi IS NULL",
		));
	}

	/**
	 * @return string
	 */
	protected function getGroupByPart()
	{
		return join(",", array(
			"qsp_set.id",
			"qsp_set.title",
			"qsp_set.description",
			"qsp_set.questionsetpool_fi"
		));
	}

	/**
	 * @param array $filter
	 *
	 * @return string
	 */
	protected function getHavingPart(array $filter)
	{
		return "";
	}

	/**
	 * @param array $params
	 *
	 * @return string
	 */
	protected function getOrderByPart(array $params)
	{
		return "";
	}
}
 