<?php

require_once "abstract.ilXTSFTableDatabaseDataProvider.php";

/**
 * Class ilFormATestSetProvider
 *
 * Date: 11.12.13
 * Time: 09:41
 * @author Thomas Joußen <tjoussen@databay.de>
 */ 
class ilFormATestSetProvider extends ilXTSFTableDatabaseDataProvider
{

	/**
	 * @return string
	 */
	protected function getSelectPart()
	{
		return join(", ", array(
			"rep_robj_xqsp_qs.id",
			"rep_robj_xtsf_qs.sorting",
			"rep_robj_xqsp_qs.title",
			"rep_robj_xqsp_qs.description",
			"rep_robj_xqsp_qs.questionsetpool_fi"
		));
	}

	/**
	 * @return string
	 */
	protected function getFromPart()
	{
		return "rep_robj_xtsf_qs";
	}

	/**
	 * @param array $filter
	 *
	 * @return string
	 */
	protected function getJoinPart(array $filter)
	{
		return "INNER JOIN rep_robj_xqsp_qs ON rep_robj_xqsp_qs.id = rep_robj_xtsf_qs.questionset_fi";
	}

	/**
	 * @param array $filter
	 *
	 * @return string
	 */
	protected function getWherePart(array $filter)
	{
		return join (" AND ", array(
			"obj_fi = " . $this->db->quote($filter["form_a_test"], "integer")
		));
	}

	/**
	 * @return string
	 */
	protected function getGroupByPart()
	{
		return "";
	}

	/**
	 * @param array $filter
	 *
	 * @return string
	 */
	protected function getHavingPart(array $filter)
	{
		return "";
	}

	/**
	 * @param array $params
	 *
	 * @return string
	 */
	protected function getOrderByPart(array $params)
	{
		return "sorting ASC";
	}
}
 