<?php

/**
 * Class ilFormATestUtil
 *
 * Date: 17.04.14
 * Time: 13:06
 * @author Thomas Joußen <tjoussen@databay.de>
 */ 
abstract class ilFormATestUtil {

	protected static $INFO_KEY = "XTSF_INFO";
	protected static $SUCCESS_KEY = "XTSF_SUCCESS";
	protected static $ERROR_KEY = "XTSF_ERROR";

	public static function addInfo($message)
	{
		self::createSessionEntryIfNotExist(self::$INFO_KEY);
		self::add(self::$INFO_KEY, $message);
	}

	public static function addSuccess($message)
	{
		self::createSessionEntryIfNotExist(self::$SUCCESS_KEY);
		self::add(self::$SUCCESS_KEY, $message);
	}

	public static function addError($message)
	{
		self::createSessionEntryIfNotExist(self::$ERROR_KEY);
		self::add(self::$ERROR_KEY, $message);
	}

	public static function send()
	{
		if(self::hasInfos())
		{
			$_SESSION["info"] = self::prepare(self::$INFO_KEY);
			self::unsetSessionEntry(self::$INFO_KEY);
		}
		if(self::hasErorrs())
		{
			$_SESSION["failure"] = self::prepare(self::$ERROR_KEY);
			self::unsetSessionEntry(self::$ERROR_KEY);
		}
		if(self::hasSuccess())
		{
			$_SESSION["success"] = self::prepare(self::$SUCCESS_KEY);
			self::unsetSessionEntry(self::$SUCCESS_KEY);
		}
	}

	protected static function hasInfos()
	{
		return count($_SESSION[self::$INFO_KEY]) > 0;
	}

	protected static function hasSuccess()
	{
		return count($_SESSION[self::$SUCCESS_KEY]) > 0;
	}

	protected static function hasErorrs()
	{
		return count($_SESSION[self::$ERROR_KEY]) > 0;
	}

	protected static function unsetSessionEntry($key)
	{
		unset($_SESSION[$key]);
	}

	protected static function prepare($key)
	{
		if(count($_SESSION[$key]) == 1)
		{
			return current($_SESSION[$key]);
		}

		$result  = "<ul><li>";
		$result .= join("</li><li>", $_SESSION[$key]);
		$result .= "</li></ul>";
		return $result;
	}

	protected static function createSessionEntryIfNotExist($key)
	{
		if(!is_array($_SESSION[$key]))
		{
			$_SESSION[$key] = array();
		}
	}

	protected static function add($key, $message)
	{
		$_SESSION[$key][] = $message;
	}

}
 