<?php

/**
 * Class ilFormATestDominantScoringReworker
 *
 * Date: 19.02.14
 * Time: 14:32
 * @author Thomas Joußen <tjoussen@databay.de>
 */ 
class ilFormATestDominantScoringReworker
{

	/**
	 * @var int
	 */
	protected $active_fi;

	/**
	 * @var int
	 */
	protected $step;

	/**
	 * @var int
	 */
	protected $pass;

	/**
	 * @var ilQuestionSetPoolNode
	 */
	protected $node;

	/**
	 * @param int $active_fi
	 * @param int $step
	 * @param int $pass
	 */
	public function __construct($active_fi, $step, $pass)
	{
		$this->active_fi = $active_fi;
		$this->step = $step;
		$this->pass = $pass;
	}

	/**
	 * @param ilQuestionSetPoolNode $node
	 */
	public function rework($node)
	{
		$this->node = $node;
		$points = $this->generateDominantPoints();
		$this->updateTstTestResult($points);
		$this->node->getQuestion()->_updateTestPassResults($this->active_fi, $this->pass);
	}

	/**
	 * @return int
	 */
	protected function generateDominantPoints()
	{
		$reached_points = $this->node->getQuestion()
							   ->getReachedPoints($this->active_fi, $this->pass);
		$max_points     = $this->node->getQuestion()->getMaximumPoints();

		if ($max_points > 0)
		{
			return round($this->node->getDominantScoring() * ($reached_points / $max_points));
		}
		return 0;
	}

	/**
	 * @param int $points
	 */
	protected function updateTstTestResult($points)
	{
		/** @var ilDB $ilDB */
		global $ilDB;

		$ilDB->update(
			"tst_test_result",
			array(
				"points" => array("integer", $points)
			),
			array(
				"active_fi" => array("integer", $this->active_fi),
				"question_fi" => array("integer", $this->node->getQuestion()->getId()),
				"step" => array("integer", $this->step),
				"pass" => array("integer", $this->pass)
			)
		);
	}
}
 