<?php

require_once './Modules/TestQuestionPool/interfaces/interface.ilQuestionHeaderBlockBuilder.php';

/**
 * Class ilFormATestParticipantQuestionHeaderBuilder
 *
 * Date: 14.01.14
 * Time: 15:28
 * @author Thomas Joußen <tjoussen@databay.de>
 */ 
class ilFormATestParticipantQuestionHeaderBuilder implements ilQuestionHeaderBlockBuilder
{

	/**
	 * @var ilPlugin
	 */
	protected $plugin;

	/**
	 * @var ilQuestionSetPoolNode
	 */
	protected $node;

	/**
	 * @var ilFormATestSession
	 */
	protected $session;

	/**
	 * @param ilPlugin $plugin
	 * @param ilQuestionSetPoolNode $node
	 * @param ilFormATestSession $session
	 */
	public function __construct($plugin, $node, $session)
	{
		$this->session = $session;
		$this->node = $node;
		$this->plugin = $plugin;
	}
	/**
	 * Get the HTML representation of the header block
	 * @return string
	 */
	public function getHTML()
	{
		$title = $this->node->getPath()->getSet()->getTitle() . " - " . $this->plugin->txt("header_step") . ": ". $this->session->getStep();

		if($this->session->hasFixatedSolution($this->node->getId()))
		{
			$title .= ' ('.$this->plugin->txt("fixated_solution") . ')';
		}
		elseif($this->session->isDeadlockPossible())
		{
			$title .= ' ('.$this->plugin->txt("fixation_possible") . ')';
		}
		return $title;
	}
}
 