<?php

require_once './Modules/TestQuestionPool/interfaces/interface.ilQuestionHeaderBlockBuilder.php';

/**
 * Class ilFormATestQuestionHeaderBuilder
 *
 * Date: 14.01.14
 * Time: 15:28
 * @author Thomas Joußen <tjoussen@databay.de>
 */ 
class ilFormATestQuestionHeaderBuilder implements ilQuestionHeaderBlockBuilder
{

	/**
	 * @var ilPlugin
	 */
	protected $plugin;

	/**
	 * @var ilQuestionSetPoolNode
	 */
	protected $node;

	/**
	 * @var ilFormATestSession
	 */
	protected $session;

	/**
	 * @param ilPlugin $plugin
	 * @param ilQuestionSetPoolNode $node
	 * @param ilFormATestSession $session
	 */
	public function __construct($plugin, $node, $session)
	{
		$this->session = $session;
		$this->node = $node;
		$this->plugin = $plugin;
	}
	/**
	 * Get the HTML representation of the header block
	 * @return string
	 */
	public function getHTML()
	{
		return sprintf(
			$this->plugin->txt("question_title"),
			$this->session->getStep(),
			$this->node->getPath()->getTitle(),
			$this->node->getQuestion()->getTitle()
		);
	}
}
 