<?php

require_once './Modules/TestQuestionPool/classes/class.ilAssQuestionList.php';

/**
 * Class ilFormATestSkillAssQuestionList
 *
 * @author  Thomas Joußen <tjoussen@databay.de>
 * @since   01.04.15
 */
class ilFormATestSkillAssQuestionList extends ilAssQuestionList
{

	/**
	 * @var array;
	 */
	protected $orderSequence;

	/**
	 * @param ilDB          $db
	 * @param ilLanguage    $lng
	 * @param ilPluginAdmin $pluginAdmin
	 * @param int           $parentObjId
	 */
	public function __construct(ilDB $db, ilLanguage $lng, ilPluginAdmin $pluginAdmin, $parentObjId)
	{
		$this->orderSequence = array();

		parent::__construct($db, $lng, $pluginAdmin);

		$this->setParentObjId($parentObjId);
	}

	public function load(ilXTSFTableDatabaseDataProvider $provider)
	{
		parent::load();

		$data = $provider->loadData(array('obj_fi' => $this->getParentObjId()));

		foreach($data as $row)
		{
			$this->orderSequence[] = $row['question_fi'];
			$questionId = $row['question_fi'];
			if(array_key_exists($questionId, $this->questions))
			{
				$title = $this->questions[$questionId]['title'];
				$this->questions[$questionId]['title'] = '(Q'. $row['question_index']. ') '. $title . ' - ' . $row['title'];
			}
		}
	}

	/**
	 * @return array
	 */
	public function getOrderSequence()
	{
		return $this->orderSequence;
	}
}
 