<#1>
<?php
if(!$ilDB->tableExists("rep_robj_xtsf_qs"))
{
	$fields = array(
		'obj_fi' => array(
			'type' => 'integer',
			'length' => '4',
			'notnull' => true
		),
		'questionset_fi' => array(
			'type' => 'integer',
			'length' => '4',
			'notnull' => false
		),
		'sorting' => array(
			'type' => 'integer',
			'length' => '4',
			'notnull' => false
		)
	);
	$ilDB->createTable("rep_robj_xtsf_qs", $fields);
	$ilDB->addPrimaryKey("rep_robj_xtsf_qs", array("obj_fi", "questionset_fi"));
}
?>
<#2>
<?php
if(!$ilDB->tableExists("rep_robj_xtsf_session"))
{
	$fields = array(
		'session_id' => array(
			'type' => 'integer',
			'length' => '4',
			'notnull' => true
		),
		'active_id' => array(
			'type' => 'integer',
			'length' => '4',
			'notnull' => true
		),
		'current_pass' => array(
			'type' => 'integer',
			'length' => '4',
			'notnull' => false
		),
		'start_date' => array(
			'type' => 'integer',
			'length' => '4',
			'notnull' => true
		),
		'end_date' => array(
			'type' => 'integer',
			'length' => '4',
			'notnull' => false
		),
	);

	$ilDB->createTable("rep_robj_xtsf_session", $fields);
	$ilDB->addPrimaryKey("rep_robj_xtsf_session", array("session_id"));
	$ilDB->createSequence("rep_robj_xtsf_session");
}
?>
<#3>
<?php
if(!$ilDB->tableExists("rep_robj_xtsf_tracking"))
{
	$fields = array(
		'session_fi' => array(
			'type' => 'integer',
			'length' => '4',
			'notnull' => true
		),
		'step' => array(
			'type' => 'integer',
			'length' => '4',
			'notnull' => true
		),
		'node_fi' => array(
			'type' => 'integer',
			'length' => '4',
			'notnull' => true
		),
	);

	$ilDB->createTable("rep_robj_xtsf_tracking", $fields);
	$ilDB->addPrimaryKey("rep_robj_xtsf_tracking", array("session_fi", "step"));
}
?>
<#4>
<?php
if(!$ilDB->tableColumnExists("rep_robj_xtsf_tracking", "set_fi"))
{
	$ilDB->addTableColumn("rep_robj_xtsf_tracking", "set_fi", array(
		'type' => 'integer',
		'length' => 4,
		'notnull' => true
	));
}
?>
<#5>
<?php
$ilDB->dropPrimaryKey("rep_robj_xtsf_tracking");
$ilDB->addPrimaryKey("rep_robj_xtsf_tracking", array("session_fi", "step", "set_fi"));
?>
<#6>
<?php
if(!$ilDB->tableExists("rep_robj_xtsf_data"))
{
	$fields = array(
		'id'      => array(
			'type'    => 'integer',
			'length'  => 4,
			'notnull' => true
		),
		'lp_mode' => array(
			'type'    => 'integer',
			'length'  => 1,
			'notnull' => true,
			'default' => 0
		)
	);
	$ilDB->createTable('rep_robj_xtsf_data', $fields);
	$ilDB->addPrimaryKey('rep_robj_xtsf_data', array('id'));
	
	$query = "SELECT od.obj_id FROM object_data od LEFT JOIN rep_robj_xtsf_data xtsfd ON xtsfd.id = od.obj_id WHERE xtsfd.id IS NULL AND od.type = " . $ilDB->quote('xtsf', 'text');
	$res = $ilDB->query($query);
	while($row = $ilDB->fetchAssoc($res))
	{
		$ilDB->manipulateF(
			'INSERT INTO rep_robj_xtsf_data (id) VALUES (%s)',
			array('integer'),
			array($row['obj_id'])
		);
	}
}
?>
<#7>
<?php
/** @var ilDB $ilDB */
if($ilDB->tableExists("rep_robj_xtsf_data"))
{
	if(!$ilDB->tableColumnExists("rep_robj_xtsf_data", "is_online"))
	{
		$ilDB->addTableColumn("rep_robj_xtsf_data", "is_online", array(
			'type' => 'integer',
			'length' => 1,
			'notnull' => false
		));
	}
	if(!$ilDB->tableColumnExists("rep_robj_xtsf_data", "max_passes"))
	{
		$ilDB->addTableColumn("rep_robj_xtsf_data", "max_passes", array(
			'type' => 'integer',
			'length' => 4,
			'notnull' => false
		));
	}
	if(!$ilDB->tableColumnExists("rep_robj_xtsf_data", "process_time"))
	{
		$ilDB->addTableColumn("rep_robj_xtsf_data", "process_time", array(
			'type' => 'integer',
			'length' => 4,
			'notnull' => false
		));
	}
	if(!$ilDB->tableColumnExists("rep_robj_xtsf_data", "allow_walk_back"))
	{
		$ilDB->addTableColumn("rep_robj_xtsf_data", "allow_walk_back", array(
			'type' => 'integer',
			'length' => 1,
			'notnull' => false
		));
	}
	if(!$ilDB->tableColumnExists("rep_robj_xtsf_data", "show_current_track"))
	{
		$ilDB->addTableColumn("rep_robj_xtsf_data", "show_current_track", array(
			'type' => 'integer',
			'length' => 1,
			'notnull' => false
		));
	}
	if(!$ilDB->tableColumnExists("rep_robj_xtsf_data", "allow_interruption"))
	{
		$ilDB->addTableColumn("rep_robj_xtsf_data", "allow_interruption", array(
			'type' => 'integer',
			'length' => 1,
			'notnull' => false
		));
	}
	if(!$ilDB->tableColumnExists("rep_robj_xtsf_data", "show_intro_statement"))
	{
		$ilDB->addTableColumn("rep_robj_xtsf_data", "show_intro_statement", array(
				'type' => 'integer',
				'length' => 1,
				'notnull' => false
			));
	}
	if(!$ilDB->tableColumnExists("rep_robj_xtsf_data", "show_final_statement"))
	{
		$ilDB->addTableColumn("rep_robj_xtsf_data", "show_final_statement", array(
				'type' => 'integer',
				'length' => 1,
				'notnull' => false
			));
	}
	if(!$ilDB->tableColumnExists("rep_robj_xtsf_data", "intro_statement"))
	{
		$ilDB->addTableColumn("rep_robj_xtsf_data", "intro_statement", array(
				'type' => 'text',
				'length' => 4000,
				'notnull' => false
			));
	}
	if(!$ilDB->tableColumnExists("rep_robj_xtsf_data", "final_statement"))
	{
		$ilDB->addTableColumn("rep_robj_xtsf_data", "final_statement", array(
				'type' => 'text',
				'length' => 4000,
				'notnull' => false
			));
	}
}
?>
<#8>
<?php
if($ilDB->tableExists("rep_robj_xtsf_session"))
{
	if(!$ilDB->tableColumnExists("rep_robj_xtsf_session", "status"))
	{
		$ilDB->addTableColumn("rep_robj_xtsf_session", "status", array(
				'type' => 'text',
				'length' => 15,
				'notnull' => false
			));
	}
}
?>
<#9>
<?php
if($ilDB->tableExists("rep_robj_xtsf_tracking"))
{


	if(!$ilDB->tableColumnExists("rep_robj_xtsf_tracking", "matched_condition_node_id"))
	{
		$ilDB->addTableColumn("rep_robj_xtsf_tracking", "matched_condition_node_id", array(
			'type' => 'integer',
			'length' => 4,
			'notnull' => false
		));
	}
	if(!$ilDB->tableColumnExists("rep_robj_xtsf_tracking", "matched_condition"))
	{
		$ilDB->addTableColumn("rep_robj_xtsf_tracking", "matched_condition", array(
				'type' => 'text',
				'length' => 4000,
				'notnull' => false
			));
	}
	if(!$ilDB->tableColumnExists("rep_robj_xtsf_tracking", "matched_condition_id"))
	{
		$ilDB->addTableColumn("rep_robj_xtsf_tracking", "matched_condition_id", array(
				'type' => 'integer',
				'length' => 4,
				'notnull' => false
			));
	}
}
?>
<#10>
<?php
if(!$ilDB->tableExists("rep_robj_xtsf_set_trck"))
{
	$fields = array(
		'session_fi' => array(
			'type' => 'integer',
			'length' => '4',
			'notnull' => true
		),
		'set_fi' => array(
			'type' => 'integer',
			'length' => '4',
			'notnull' => true
		),
		'status' => array(
			'type' => 'text',
			'length' => 15,
			'notnull' => false
		),
	);

	$ilDB->createTable("rep_robj_xtsf_set_trck", $fields);
	$ilDB->addPrimaryKey("rep_robj_xtsf_set_trck", array("session_fi", "set_fi"));
}
?>
<#11>
<?php
/** @var ilDB $ilDB */
if($ilDB->tableExists("rep_robj_xtsf_data"))
{
	if(!$ilDB->tableColumnExists("rep_robj_xtsf_data", "show_questions_overview"))
	{
		$ilDB->addTableColumn("rep_robj_xtsf_data", "show_questions_overview", array(
				'type' => 'integer',
				'length' => 1,
				'notnull' => false
			));
	}
}
?>
<#12>
<?php
/** @var ilDB $ilDB */
if($ilDB->tableExists("rep_robj_xtsf_tracking"))
{
	if(!$ilDB->tableColumnExists("rep_robj_xtsf_tracking", "current_position"))
	{
		$ilDB->addTableColumn("rep_robj_xtsf_tracking", "current_position", array(
				'type' => 'integer',
				'length' => 1,
				'notnull' => false
			));
	}
}
?>
<#13>
<?php
if(!$ilDB->tableExists("rep_robj_xtsf_solut"))
{
	$fields = array(
		'solution_id' => array(
			'type' => 'integer',
			'length' => '4',
			'notnull' => true
		),
		'active_fi' => array(
			'type' => 'integer',
			'length' => '4',
			'notnull' => true
		),
		'question_fi' => array(
			'type' => 'integer',
			'length' => '4',
			'notnull' => true
		),
		'points' => array(
			'type' => 'integer',
			'length' => '4',
			'notnull' => false
		),
		'pass' => array(
			'type' => 'integer',
			'length' => '4',
			'notnull' => true
		),
		'tstamp' => array(
			'type' => 'integer',
			'length' => '4',
			'notnull' => true
		),
		'value1' => array(
			"type" => "clob",
			'notnull' => false
		),
		'value2' => array(
			"type" => "clob",
			'notnull' => false
		),
		'step' => array(
			'type' => 'integer',
			'length' => '4',
			'notnull' => false
		),
	);
	$ilDB->createTable("rep_robj_xtsf_solut", $fields);
	$ilDB->addPrimaryKey("rep_robj_xtsf_solut", array("solution_id"));
	$ilDB->addIndex("rep_robj_xtsf_solut", array("question_fi"), "i1");
	$ilDB->addIndex("rep_robj_xtsf_solut", array("active_fi"), "i2");
}
?>
<#14>
<?php
if(!$ilDB->tableExists("rep_robj_xtsf_trck_his"))
{
	$fields = array(
		'session_fi' => array(
			'type' => 'integer',
			'length' => '4',
			'notnull' => true
		),
		'step' => array(
			'type' => 'integer',
			'length' => '4',
			'notnull' => true
		),
		'node_fi' => array(
			'type' => 'integer',
			'length' => '4',
			'notnull' => true
		),
		'set_fi' => array(
			'type' => 'integer',
			'length' => '4',
			'notnull' => false
		),
		'matched_condition_node_id' => array(
			'type' => 'integer',
			'length' => '4',
			'notnull' => false
		),
		'matched_condition' => array(
			'type' => 'text',
			'length' => 4000,
			'notnull' => false
		),
		'matched_condition_id' => array(
			"type" => "integer",
			"length" => 4,
			'notnull' => false
		),
	);
	$ilDB->createTable("rep_robj_xtsf_trck_his", $fields);
	$ilDB->addPrimaryKey("rep_robj_xtsf_trck_his", array("session_fi", "step", "set_fi"));
}
?>
<#15>
<?php
if($ilDB->tableExists("rep_robj_xtsf_solut"))
{
	$ilDB->dropPrimaryKey("rep_robj_xtsf_solut");
	$ilDB->addPrimaryKey("rep_robj_xtsf_solut", array("solution_id", "step"));
}
?>
<#16>
<?php
/** @var ilDB $ilDB */
if($ilDB->tableExists("rep_robj_xtsf_tracking"))
{
	if($ilDB->tableColumnExists("rep_robj_xtsf_tracking", "current_position"))
	{
		$ilDB->dropTableColumn("rep_robj_xtsf_tracking", "current_position");
	}
}
?>
<#17>
<?php
if($ilDB->tableExists("rep_robj_xtsf_tracking"))
{
	$ilDB->dropPrimaryKey("rep_robj_xtsf_tracking");
	$ilDB->addPrimaryKey("rep_robj_xtsf_tracking", array("session_fi", "step", "set_fi"));
}
?>
<#18>
<?php
if($ilDB->tableExists("rep_robj_xtsf_solut"))
{
	$ilDB->addTableColumn("rep_robj_xtsf_solut", "fixated", array(
		'type' => 'integer',
		'length' => 1,
		'notnull' => false
	));
}
?>
<#19>
<?php
if($ilDB->tableExists("rep_robj_xtsf_data"))
{
	$ilDB->addTableColumn("rep_robj_xtsf_data", "node_fb_author", array(
		'type' => 'integer',
		'length' => 1,
		'notnull' => true,
		'default' => 0
	));	
}
?>
<#20>
<?php
if($ilDB->tableExists("rep_robj_xtsf_data"))
{
	$ilDB->addTableColumn("rep_robj_xtsf_data", "node_fb_part", array(
		'type' => 'integer',
		'length' => 1,
		'notnull' => true,
		'default' => 0
	));
}
?>
<#21>
<?php
if(!$ilDB->tableExists('rep_robj_xtsf_fbt'))
{
	$fields = array(
		'session_id' => array(
			'type' => 'integer',
			'length' => 4,
			'notnull' => true
		),
		'step' => array(
			'type' => 'integer',
			'length' => 4,
			'notnull' => true
		),
		'node_id' => array(
			'type' => 'integer',
			'length' => 4,
			'notnull' => true
		),
		'set_id' => array(
			'type' => 'integer',
			'length' => 4,
			'notnull' => false
		),
		'condition_id' => array(
			"type" => "integer",
			"length" => 4,
			'notnull' => false
		),
		'feedback_type' => array(
			"type" => "integer",
			"length" => 1,
			'notnull' => true
		)
	);

	$ilDB->createTable('rep_robj_xtsf_fbt', $fields);
	$ilDB->addPrimaryKey("rep_robj_xtsf_fbt", array("session_id", "step", "node_id", "feedback_type"));
}
?>
<#22>
<?php
if($ilDB->tableExists("rep_robj_xtsf_data"))
{
	$ilDB->addTableColumn("rep_robj_xtsf_data", "node_fb_part_res", array(
		'type' => 'integer',
		'length' => 1,
		'notnull' => true,
		'default' => 0
	));
}
?>
<#23>
<?php
if($ilDB->tableExists('rep_robj_xtsf_fbt'))
{
	if(!$ilDB->tableColumnExists('rep_robj_xtsf_fbt', 'fbt_time'))
	{
		$ilDB->addTableColumn('rep_robj_xtsf_fbt', 'fbt_time', array(
			'type'    => 'integer',
			'length'  => 4,
			'notnull' => true,
			'default' => 0
		));
	}	
}
?>
<#24>
<?php
if($ilDB->tableExists('rep_robj_xtsf_fbt'))
{
	if(!$ilDB->tableColumnExists('rep_robj_xtsf_fbt', 'fbt_id'))
	{
		$ilDB->addTableColumn('rep_robj_xtsf_fbt', 'fbt_id', array(
			'type'    => 'integer',
			'length'  => 4,
			'notnull' => true,
			'default' => 0
		));
	}
}

$query = "SELECT * FROM rep_robj_xtsf_fbt";
$res   = $ilDB->query($query);
$counter = 1;
while($row = $ilDB->fetchAssoc($res))
{
	$ilDB->update(
		'rep_robj_xtsf_fbt',
		array(
			'fbt_id' => array('integer', $counter)
		),
		array(
			'session_id'    => array('integer', $row['session_id']),
			'step'          => array('integer', $row['step']),
			'node_id'       => array('integer', $row['node_id']),
			'feedback_type' => array('integer', $row['feedback_type'])
		)
	);
	++$counter;
}
$ilDB->dropPrimaryKey('rep_robj_xtsf_fbt');
$ilDB->addPrimaryKey('rep_robj_xtsf_fbt', array('fbt_id'));
$ilDB->createSequence('rep_robj_xtsf_fbt', $counter + 1);
?>
<#25>
<?php
?>
<#26>
<?php

if(!$ilDB->indexExistsByFields('rep_robj_xtsf_fbt', array('session_id')))
{
	$ilDB->addIndex("rep_robj_xtsf_fbt", array("session_id"), "i1");	
}

if(!$ilDB->indexExistsByFields('rep_robj_xtsf_fbt', array('node_id')))
{
	$ilDB->addIndex("rep_robj_xtsf_fbt", array("node_id"), "i2");
}

if(!$ilDB->indexExistsByFields('rep_robj_xtsf_fbt', array('set_id')))
{
	$ilDB->addIndex("rep_robj_xtsf_fbt", array("set_id"), "i3");
}

if(!$ilDB->indexExistsByFields('rep_robj_xtsf_fbt', array('condition_id')))
{
	$ilDB->addIndex("rep_robj_xtsf_fbt", array("condition_id"), "i4");
}

if(!$ilDB->indexExistsByFields('rep_robj_xtsf_tracking', array('node_fi')))	
{
	$ilDB->addIndex("rep_robj_xtsf_tracking", array("node_fi"), "i1");
}

if(!$ilDB->indexExistsByFields('rep_robj_xtsf_trck_his', array('node_fi')))
{
	$ilDB->addIndex("rep_robj_xtsf_trck_his", array("node_fi"), "i2");
}
?>
